/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

//main.cc file for YAPI Process Networks
//@Author: ESPAM
 
#include "mjpeg_KPN.h"
#include <fstream>
using namespace std;
 
int main()
{
 
   mjpeg mjpeg( id("mjpeg"));
 
       RTE rte;
 
	// start the processes and
	// wait for processes to finish
 
	rte.start(mjpeg);
 
	// generate dotty file
	ofstream i("./mjpeg_KPN.dot");
	printDotty(mjpeg, i);
 
	// generate workload information
	printComputationWorkload(mjpeg);
	printCommunicationWorkload(mjpeg);
 
	i.close();
 
}
