/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include "mjpeg_func.h"

int main(int argc, char **argv)
{
        int t, j, i;

	THeaderInfo     hi;
	TPackets        stream;
static	TBlocks block[VNumBlocks][HNumBlocks];


	for (t = 0; t < NumFrames; t++) {

		initVideoIn (&hi);

		for (j = 1; j <= VNumBlocks; j++) {
			for (i = 1; i <= HNumBlocks; i++) {
				mainVideoIn(&block[j-1][i-1]);
			}
		}

		for (j = 1; j <= VNumBlocks; j++) {
		   for (i = 1; i <= HNumBlocks; i++) {

                      if (i >= 1) {
                        if (4*i <= HNumBlocks) {
			   mainDCT(&block[j-1][i-1], &block[j-1][i-1]);
			   mainQ(&block[j-1][i-1], &block[j-1][i-1]);
                        }
                      }  
                      if (4*i >= HNumBlocks + 4) {
                        if (4*i <=  2*HNumBlocks) {
			   mainDCT(&block[j-1][i-1], &block[j-1][i-1]);
			   mainQ(&block[j-1][i-1], &block[j-1][i-1]);
                        }
                      }  
                      if (4*i >= 2*HNumBlocks + 4) {
                        if (4*i <=  3*HNumBlocks) {
			   mainDCT(&block[j-1][i-1], &block[j-1][i-1]);
			   mainQ(&block[j-1][i-1], &block[j-1][i-1]);
                        }
                      }  
                      if (4*i >= 3*HNumBlocks + 4) {
                        if (4*i <=  4*HNumBlocks) {
			   mainDCT(&block[j-1][i-1], &block[j-1][i-1]);
			   mainQ(&block[j-1][i-1], &block[j-1][i-1]);
                        }
                      }  

		   }
		}

		for (j = 1; j <= VNumBlocks; j++) {
			for (i = 1; i <= HNumBlocks; i++) {
				mainVLE(&block[j-1][i-1], &stream);
				mainVideoOut(&hi, &stream);
			}
		}

	}
	
	return (0);
}
