/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef MJPEG_FUNC_H
#define MJPEG_FUNC_H

#include "types.h"

#define NumFrames  32
#define VNumBlocks  16
#define HNumBlocks  8

void initVideoIn(THeaderInfo *HeaderInfo);
void mainVideoIn(TBlocks *out);

void mainDCT(const TBlocks *input, TBlocks *output);

void mainQ(const TBlocks *input, TBlocks *output);

void mainVLE(const TBlocks *blocks, TPackets *stream);

void mainVideoOut(const THeaderInfo *HeaderInfo, const TPackets *stream);

#endif
